<script>
import { mapActions, mapGetters } from "vuex";
import Calculator from "./components/Calculator";
import Bill from "./components/Bill";
export default {
  name: "App",
  components: {
    Calculator,
    Bill,
  },
  data: () => ({
    currencySwitch: true,
    price: 0,
    tip: 10,
    minTip: 10,
    maxTip: 20,
    people: 2,
    minPeople: 2,
    maxPeople: 16,
    loadingQuote: false,
    currency: {
      label: "$",
      value: "USD",
    },
    next: false,
  }),
  watch: {
    async currencySwitch() {
      this.currencySwitch
        ? (this.currency = {
            label: "$",
            value: "USD",
          })
        : (this.currency = {
            label: "€",
            value: "EUR",
          });
      this.loadingQuote = true;
      await this.listCurrencies(this.currency.value);
      this.loadingQuote = false;
    },
  },
  async mounted() {
    this.loadingQuote = true;
    await this.listCurrencies(this.currency.value);
    this.loadingQuote = false;
  },
  computed: {
    ...mapGetters(["getCurrency"]),
    finalTip() {
      if (this.price != 0) {
        let result = String(this.price * (this.tip / 100));
        if (result.includes(".")) {
          result = result.split(".");
          if (result.length > 1)
            result = result[0] + "." + result[1].substr(0, 3);
        } else {
          result = result + ".00";
        }
        return result;
      } else {
        return "0.000";
      }
    },
    finalPrice() {
      if (this.price != 0 && this.finalTip != "0.00") {
        let result = String(parseFloat(this.price) + parseFloat(this.finalTip));
        // result = String(result);
        if (result.includes(".")) {
          result = result.split(".");
          if (result.length > 1)
            result = result[0] + "." + result[1].substr(0, 2);
        } else {
          result = result + ".00";
        }
        return result;
      } else return "0.00";
    },
    perPeople() {
      return (parseFloat(this.finalPrice) / +this.people).toFixed(2);
    },
    calcWithQuote() {
      return (parseFloat(this.finalPrice) * this.getCurrency.quote).toFixed(2);
    },
  },
  methods: {
    ...mapActions(["listCurrencies"]),
  },
};
</script>

<template>
  <v-app>
    <v-main>
      <v-container class="mb-6">
        <v-row justify="space-around" no-gutters>
          <v-col class="py-14" cols="12">
            <h1 class="display-2 font-weight-bold mb-3 text-center">Le/Tip</h1>
          </v-col>
          <v-col v-if="!next" cols="12" xl="3" lg="4" md="4" sm="5" xs="12">
            <Calculator
              :currencySwitch.sync="currencySwitch"
              :price.sync="price"
              :tip.sync="tip"
              :minTip="minTip"
              :maxTip="maxTip"
              :people.sync="people"
              :minPeople="minPeople"
              :maxPeople="maxPeople"
            />
          </v-col>
          <v-col v-if="!$vuetify.breakpoint.xs || next" cols="12" sm="4">
            <Bill
              :currency="currency"
              :price="price"
              :finalTip="finalTip"
              :finalPrice="finalPrice"
              :perPeople="perPeople"
              :loadingQuote="loadingQuote"
              :calcWithQuote="calcWithQuote"
            />
          </v-col>
        </v-row>
        <v-btn
          fab
          bottom
          right
          absolute
          class="mb-10"
          color="primary"
          @click="next = !next"
          v-if="$vuetify.breakpoint.xs"
        >
          <v-icon>{{ next ? "mdi-chevron-left" : "mdi-chevron-right" }}</v-icon>
        </v-btn>
      </v-container>
    </v-main>
  </v-app>
</template>
